/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: qrybststpp.m,v 1.6 92/06/11 16:16:46 rws Exp $
 */
>>TITLE XQueryBestStipple CH05
Status
QueryBestStipple(display, drawable, width, height, rwidth, rheight)
Display *display = Dsp;
Drawable drawable;
unsigned int width;
unsigned int height;
unsigned int *rwidth = &bwidth;
unsigned int *rheight = &bheight;
>>EXTERN
unsigned int bwidth, bheight;
>>ASSERTION Good A
A call to xname returns the height and width of stipple that are closest to the arguments
.A height
and
.A width
that can be stippled fastest on the specified screen.
>>STRATEGY
Call XQueryBestStipple with width 17 and height 13.
Verify that XQueryBestStipple returns non zero.
Call XQueryBestStipple with returned values of width and height.
Verify that XQueryBestStipple returns non zero.
Verify that XQueryBestStipple returns the previously returned values
for width and height.
Repeat with initial width and height both set to zero.
>>CODE
Status qstat;

	drawable = DRW(display);

	width = 17;
	height = 13;

	qstat = XCALL;

	if(qstat == 0) {
		report("XQueryBestStipple returned wrong value %d", qstat);
		FAIL;
	} else
		CHECK;

	trace("Status returned was %d", qstat);
	trace("Best width (for 17)  = %d",bwidth);
	trace("Best height (for 13) = %d",bheight);

	width = bwidth;
	height = bheight;

	bwidth = bheight = 0;

	qstat = XCALL;

	if(qstat == 0) {
		report("XQueryBestStipple returned wrong value %d", qstat);
		FAIL;
	} else
		CHECK;

	trace("Status returned was %d", qstat);
	trace("Best width (for %d)  = %d", width, bwidth);
	trace("Best height (for %d) = %d", height, bheight);

	if(width != bwidth) {
		report("XQueryBestStipple returned best width %d", bwidth);
		report("after previously returning best width %d", width);
		FAIL;
	} else
		CHECK;

	if(height != bheight) {
		report("XQueryBestStipple returned best height %d", bheight);
		report("after previously returning best height %d", height);
		FAIL;
	} else
		CHECK;

	width = 0;
	height = 0;

	qstat = XCALL;

	if(qstat == 0) {
		report("XQueryBestStipple returned wrong value %d", qstat);
		FAIL;
	} else
		CHECK;

	trace("Status returned was %d", qstat);
	trace("Best width (for 0)  = %d",bwidth);
	trace("Best height (for 0) = %d",bheight);

	width = bwidth;
	height = bheight;

	bwidth = bheight = 0;

	qstat = XCALL;

	if(qstat == 0) {
		report("XQueryBestStipple returned wrong value %d", qstat);
		FAIL;
	} else
		CHECK;

	trace("Status returned was %d", qstat);
	trace("Best width (for %d)  = %d", width, bwidth);
	trace("Best height (for %d) = %d", height, bheight);

	if(width != bwidth) {
		report("XQueryBestStipple returned best width %d", bwidth);
		report("after previously returning best width %d", width);
		FAIL;
	} else
		CHECK;

	if(height != bheight) {
		report("XQueryBestStipple returned best height %d", bheight);
		report("after previously returning best height %d", height);
		FAIL;
	} else
		CHECK;

	CHECKPASS(8);
>>ASSERTION Bad A
.ER Drawable
>>ASSERTION Bad A
.ER Match inputonly
>># HISTORY cal Completed	Written in new format and style
>># HISTORY kieron Completed	Global and pixel checking to do - 19/11/90
>># HISTORY dave Completed	Final checking to do - 21/11/90
>># HISTORY cal Action		Writing code.
