/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: unqcntxt.m,v 1.3 92/06/11 17:43:52 rws Exp $
 */
>>TITLE XUniqueContext CH10
XContext

>>ASSERTION Good A
A call to xname returns a unique context type identifier.
>>STRATEGY
Call xname to obtain a unique context type identifier.
Call xname to obtain another unique context identifier.
Verify the context type identifiers are unique.
>>CODE
XContext a,b;

/* Call xname to obtain a unique context type identifier. */
	a = XCALL;

/* Call xname to obtain another unique context identifier. */
	b = XCALL;

/* Verify the context type identifiers are unique. */
	if (a==b) {
		FAIL;
		report("%s returned identical context identifiers on subsequent calls.",
			TestName);
	} else
		CHECK;

	CHECKPASS(1);
